%define major_c 3
%define major_cpp 8
%define libxmlrpc_c %mklibname xmlrpc %{major_c}
%define libxmlrpc_cpp %mklibname xmlrpc++ %{major_cpp}
%define libxmlrpc_ccpp %mklibname xmlrpc_cpp %{major_cpp}
%define libxmlrpc_abyss_c %mklibname xmlrpc_abyss %{major_c}
%define libxmlrpc_client_c %mklibname xmlrpc_client %{major_c}
%define libxmlrpc_client_cpp %mklibname xmlrpc_client++ %{major_cpp}
%define libxmlrpc_packetsocket_c %mklibname xmlrpc_packetsocket %{major_cpp}
%define libxmlrpc_server_c %mklibname xmlrpc_server %{major_c}
%define libxmlrpc_server_cpp %mklibname xmlrpc_server++ %{major_cpp}
%define libxmlrpc_server_abyss_c %mklibname xmlrpc_server_abyss %{major_c}
%define libxmlrpc_server_abyss_cpp %mklibname xmlrpc_server_abyss++ %{major_cpp}
%define libxmlrpc_server_cgi_c %mklibname xmlrpc_server_cgi %{major_c}
%define libxmlrpc_server_cgi_cpp %mklibname xmlrpc_server_cgi++ %{major_cpp}
%define libxmlrpc_server_pstream_cpp %mklibname xmlrpc_server_pstream++ %{major_cpp}
%define libxmlrpc_util_c %mklibname xmlrpc_util %{major_c}
%define devname %mklibname %{name} -d

%global advanced_branch 1
%global svnrev 2451

Summary:	Programming library for writing an XML-RPC server or client in C or C++
Name:		xmlrpc-c
Version:	1.32.5
Release:	1
License:	BSD
Group:		System/Libraries
Url:		http://xmlrpc-c.sourceforge.net/
%{!?advanced_branch:Source0:	http://dl.sourceforge.net/sourceforge/xmlrpc-c/xmlrpc-%{version}.tgz}
# generated by 'make svn-sources [SVN_VER=%version SVN_REV=%svnrev]'. Unfortunately,
# upstream does not tag versions so we must fetch from the branch and
# check which version was used for it
%{?advanced_branch:Source0:	xmlrpc-c-%{version}.tar.xz}
Source100:	dfs.cc
Source101:	dso-fixup

# Fedora patches
Patch100:	xmlrpc-c-cmake.patch
Patch102:	xmlrpc-c-printf-size_t.patch
Patch105:	xmlrpc-c-longlong.patch
Patch107:	xmlrpc-c-uninit-curl.patch
Patch108:	xmlrpc-c-30x-redirect.patch
Patch109:	xmlrpc-c-check-vasprintf-return-value.patch
Patch110:	xmlrpc-c-include-string_int.h.patch
Patch111:	xmlrpc-c-format-security-warning.patch
BuildRequires:	cmake
BuildRequires:	readline-devel
BuildRequires:	pkgconfig(libcurl)
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	pkgconfig(ncurses)

%description
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files
%doc doc/COPYING doc/CREDITS doc/DEVELOPING doc/HISTORY doc/SECURITY doc/TESTING doc/TODO
%{_bindir}/xmlrpc
%{_bindir}/xmlrpc_parsecall
%{_bindir}/xmlrpc_pstream
%{_bindir}/xmlrpc_transport
%{_bindir}/xml-rpc-api2cpp
%{_bindir}/xml-rpc-api2txt
%{_bindir}/xmlrpc_cpp_proxy
%{_mandir}/man1/xml-rpc-api2cpp.1*
%{_mandir}/man1/xml-rpc-api2txt.1*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5
Obsoletes:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_c}
%{_libdir}/libxmlrpc.so.%{major_c}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_cpp}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_cpp}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_cpp}
%{_libdir}/libxmlrpc++.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_ccpp}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_ccpp}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_ccpp}
%{_libdir}/libxmlrpc_cpp.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_abyss_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_abyss_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_abyss_c}
%{_libdir}/libxmlrpc_abyss.so.%{major_c}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_client_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_client_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_client_c}
%{_libdir}/libxmlrpc_client.so.%{major_c}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_client_cpp}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_client_cpp}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_client_cpp}
%{_libdir}/libxmlrpc_client++.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_packetsocket_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_packetsocket_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_packetsocket_c}
%{_libdir}/libxmlrpc_packetsocket.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_server_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_server_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_server_c}
%{_libdir}/libxmlrpc_server.so.%{major_c}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_server_cpp}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_server_cpp}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_server_cpp}
%{_libdir}/libxmlrpc_server++.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_server_abyss_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_server_abyss_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_server_abyss_c}
%{_libdir}/libxmlrpc_server_abyss.so.%{major_c}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_server_abyss_cpp}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_server_abyss_cpp}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_server_abyss_cpp}
%{_libdir}/libxmlrpc_server_abyss++.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_server_cgi_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_server_cgi_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_server_cgi_c}
%{_libdir}/libxmlrpc_server_cgi.so.%{major_c}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_server_cgi_cpp}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_server_cgi_cpp}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_server_cgi_cpp}
%{_libdir}/libxmlrpc_server_cgi++.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_server_pstream_cpp}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_server_pstream_cpp}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_server_pstream_cpp}
%{_libdir}/libxmlrpc_server_pstream++.so.%{major_cpp}*

#----------------------------------------------------------------------------

%package -n %{libxmlrpc_util_c}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Conflicts:	%{_lib}xmlrpc-c3 < 1.32.5

%description -n %{libxmlrpc_util_c}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

%files -n %{libxmlrpc_util_c}
%{_libdir}/libxmlrpc_util.so.%{major_c}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Programming library for writing an XML-RPC server or client in C or C++
Group:		System/Libraries
Requires:	%{libxmlrpc_c} = %{EVRD}
Requires:	%{libxmlrpc_cpp} = %{EVRD}
Requires:	%{libxmlrpc_ccpp} = %{EVRD}
Requires:	%{libxmlrpc_abyss_c} = %{EVRD}
Requires:	%{libxmlrpc_client_c} = %{EVRD}
Requires:	%{libxmlrpc_client_cpp} = %{EVRD}
Requires:	%{libxmlrpc_packetsocket_c} = %{EVRD}
Requires:	%{libxmlrpc_server_c} = %{EVRD}
Requires:	%{libxmlrpc_server_cpp} = %{EVRD}
Requires:	%{libxmlrpc_server_abyss_c} = %{EVRD}
Requires:	%{libxmlrpc_server_abyss_cpp} = %{EVRD}
Requires:	%{libxmlrpc_server_cgi_c} = %{EVRD}
Requires:	%{libxmlrpc_server_cgi_cpp} = %{EVRD}
Requires:	%{libxmlrpc_server_pstream_cpp} = %{EVRD}
Requires:	%{libxmlrpc_util_c} = %{EVRD}
Requires:	pkgconfig(libxml-2.0)
Provides:	%{name}-devel = %{EVRD}
Provides:	lib%{name}-devel = %{EVRD}

%description -n %{devname}
XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
It converts the procedure call into XML document, sends it to a remote
server using HTTP, and gets back the response as XML.

This library provides a modular implementation of XML-RPC for C and C++.

This package contains the developement files.

%files -n %{devname}
%{_bindir}/xmlrpc-c-config
%{_includedir}/*.h
%{_includedir}/%{name}
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*.pc

#----------------------------------------------------------------------------

%prep
%setup -q
%apply_patches

%build
%cmake \
	-D_lib:STRING=%{_lib} \
	-DMUST_BUILD_CURL_CLIENT:BOOL=ON \
	-DMUST_BUILD_LIBWWW_CLIENT:BOOL=OFF \
	-DENABLE_TOOLS:BOOL=ON

%__cxx %{optflags} %{SOURCE100} -o depsort

%make

%install
cd build
%makeinstall_std

bash %{SOURCE101} "%{buildroot}" "%{_libdir}" 'libxmlrpc' %{buildroot}%{_libdir}/libxmlrpc*.so.[0-9]

%check
unset PKG_CONFIG_PATH
export PKG_CONFIG_LIBDIR=%{buildroot}%{_libdir}/pkgconfig:%{_libdir}/pkgconfig:%{_datadir}/pkgconfig
PATH=%{buildroot}%{_bindir}:$PATH

_e() {
     echo "\$ $@"
     "$@"
}

set +x
_e xmlrpc-c-config --help
for comp in c++ cgi-server server-util abyss-server client libwww-client; do
	for opt in '--version' '--libs' 'c++2 --libs' 'c++ --libs --static'; do
		_e xmlrpc-c-config "$comp" $opt
	done
done
set -x


%changelog

* Thu Dec 10 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.32.5-1
- (71e833a) Split libraries into individual packages


